//proj2Applet.java
import java.util.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.rmi.*;
import java.applet.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
 
public class proj2Applet extends Applet {
 
  public myDBC obj;
  public Panel headerPanel;
  private boolean isclose = true;
  private proj2DisplayPanel dp;  TextArea usageBoard;
     public void init() {
    String url = getParameter( "url" );
    try{
     obj = ( myDBC )Naming.lookup( url );
     obj.open();
    }
    catch( Exception ex ){
     System.out.println( "proj2Applet:Exception " + ex );
     ex.printStackTrace();
    }
  }

  public proj2Applet() {
    // set background color to lightGray, add HeaderPanel,
    //DisplayPanel and controlPanel components
    setBackground(Color.lightGray);
    headerPanel = new Panel();
    headerPanel.setFont(new Font("Helvetica", Font.PLAIN, 24));
    headerPanel.add(new Label("The Detail Information of Trip "));
    add("North", headerPanel);
    add("Center", dp = new proj2DisplayPanel());
    add("South",  new proj2ControlPanel(this));	
	usageBoard= new TextArea("",6,60,1);
    usageBoard.setBackground(Color.white);
    usageBoard.setForeground(Color.black);
    add(usageBoard,BorderLayout.SOUTH);
    usageBoard.append("                USER INSTRUCTION \n");
    usageBoard.append("This is a interesting database which you can get many information\n");
    usageBoard.append(" about the trip in China. Such as : the ticked price ,the total price \n");
usageBoard.append("this trip,which condition will be included and so on.\n");
usageBoard.append("Follow information can help you search database information:\n");
usageBoard.append("You can put the name of start place in the labl of 'Search by FIRST';\n");
usageBoard.append("The key word in the database is 'Shanghai','Tianjing,'Xiameng'\n\n");
usageBoard.append("You can put the name of final place in the labl of 'Search by LAST'\n");
usageBoard.append("The key word in the database is 'Hangzhou','Beijing','Nianjing'\n");
usageBoard.append("The key word in the database is 'Zhenjiang'\n");
usageBoard.append("You can put the condition you want to search in the labl of\n");
usageBoard.append("'Search by condition'\n");
usageBoard.append("The key word in the database is 'food/hotel/3Ds/air',\n");
usageBoard.append("'food/hotel/4Ds/train','food/hotel/7Ds/train','food/hotel/5Ds/air',\n");
usageBoard.append("'food/5Dfood/hotel/3Ds/airs/air','food//7Ds/train'.\n");

usageBoard.append("you will also can get the information of the Total price.\n");
usageBoard.append("Have a good Holiday!\n\n");
  }
 
  
  // search for the name specified in the database
  public void search( String a, String b, int key  ) {
    Vector vect = new Vector();

    // search for string a,b; result returned by Vector 
    try {
     if ( key == 1 ){
      vect = obj.searchtrip( a, b );
      if( vect.size() != 0 ) 
       dp.show( vect );
      else {
       dp.showerr( 0 );       //not any inf be found
      }//else not inf be found.
     }// if look for trip table.
     else{ //look for trip_add table
      vect = obj.searchcondition(a);
      if( vect.size() != 0 ) 
        dp.show( vect );
      else {
        dp.showerr( 1 );       //not a style be found
      }//else not a style be found.
     }// else look for trip table.
   }//try
    catch( Exception ex ){
     System.out.println( "proj2Applet:Exception " + ex );
     ex.printStackTrace();
    }
  }

 /* //search meta data of two tables
  public void searchMeta() {
    Vector vect = new Vector();
 
    // search for table's meta data; result returned in Vector
    try {
      vect = obj.meta_Data();
      if( vect.size() != 0 )
       dp.show( vect );
      else {
       dp.showerr( 2 );       //not meta data be found
      }//else not data be found.
   }//try
    catch( Exception ex ){
     System.out.println( "proj2Applet:Exception " + ex );
     ex.printStackTrace();
    }
  }
*/

  //change the data of a trip
   public void update( String a, String b, String c, String d ) {
    try {
      if( c.equals("") || d.equals("") || c == null || d == null )
        dp.showerr( 3 );//type in the data, style and price
      else 
        obj.updatetrip(a, b, c, d );
    }
    catch( Exception ex ){   
     System.out.println( "proj2Applet:Exception " + ex );
     ex.printStackTrace();
    }
   }
 
  //add a trip
   public void adddate( String a, String b, String c, String d ) {
    try {
      if( c.equals("") || d.equals("") || c == null || d == null )
         dp.showerr( 3 );  //type in number and ticket
      else
         obj.adddatetrip(a, b, c, d );
    }
    catch( Exception ex ){   
     System.out.println( "proj2Applet:Exception " + ex );
     ex.printStackTrace();
    }
   }
 
   public void delete_date( String a, String b ) {
    try {
      if( a.equals("") || b.equals("") || a == null || b == null )
        dp.showerr( 0 );  // can not find the name
      else
        obj.delete_trip( a, b );
      }
    catch( Exception ex ){   
     System.out.println( "proj2Applet:Exception " + ex );
     ex.printStackTrace();
    }
   }

  public void open() {
    try {
      if( isclose ){
        isclose = false;
        dp.showStatus( 0 );   //is close
        obj.open();}//else
      else {
        dp.showStatus( 1 );
        dp.repaint();
      }//else
    }
    catch( Exception ex ){   
     System.out.println( "proj2Applet:Exception " + ex );
     ex.printStackTrace();
    }
   }

  public void close() {
    try{
      if( isclose )
        dp.showStatus( 3 );   //is close
      else {
        dp.showStatus( 2 );
        obj.close();
      }//else
    }
    catch( Exception ex ){   
     System.out.println( "proj2Applet:Exception " + ex );
     ex.printStackTrace();
    }
   }

}

 

